﻿
using System.Collections;
using System.Collections.Generic;
using System.Windows;

namespace WpfApp2
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            PropertyGrid.SelectedObject = GenerateData();
        }

        private IList<IDetailsViewModel> GenerateData()
        {
            var result = new List<IDetailsViewModel>();
            var details = new DetailsViewModel
            {
                Name = "Some category"
            };

            details.Properties.Add(new PropertyViewModel
            {
                Name = "simple1",
                Value = 2,
                ValueType = typeof(int)
            });

            details.Properties.Add(new PropertyViewModel
            {
                Name = "simple2",
                Value = "some text",
                ValueType = typeof(string)
            });

            details.Properties.Add(new PropertyViewModel
            {
                Name = "expandable ok",
                Properties = new List<IPropertyViewModel>
                {
                    new PropertyViewModel
                    {
                        Name = "expandable further not ok",
                        Properties = new List<IPropertyViewModel>
                        {
                            new PropertyViewModel
                            {
                                Name = "some prop",
                                ValueType = typeof(string),
                                Value = "some value"
                            }
                        }
                    }
                }
            });

            details.Properties.Add(new PropertyViewModel
            {
                Name = "expandable not ok",
                Properties = new List<IPropertyViewModel>
                {
                    new PropertyViewModel
                    {
                        Name = "some prop",
                        ValueType = typeof(string),
                        Value = "some value"
                    },
                    new PropertyViewModel
                    {
                        Name = "expandable further",
                        Properties = new List<IPropertyViewModel>
                        {
                            new PropertyViewModel
                            {
                                Name = "some prop",
                                ValueType = typeof(string),
                                Value = "some value"
                            }
                        }
                    }
                }
            });

            result.Add(details);

            return result;
        }
    }
}
